{
Example 2 for using the LP/QP solver DLL bpmpd. This program solves problems
from MPS/QPS files.
The external DLL mpsinp reads an MPS file. It places the representation of
Q after the constraint matrix that is indices of Q begin from colidx[nz+1],
nonzeros of Q begin from colnzs[nz+1].
The program demonstrates the memory usage of the DLL by passing usemem=0,
then it writes how much memory was allocated during the execution of bpmpd.
}



unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit6: TEdit;
    Label6: TLabel;
    Edit7: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
 const maxm=  4000;
 const maxn=  8000;
 const maxnz=24000;

 type tnz =array [1..maxnz] of integer;
 type tn  =array [1..maxn] of integer;
 type tmn =array [1..maxm+maxn] of integer;
 type tdnz=array [1..maxnz] of double;
 type tdm =array [1..maxm] of double;
 type tdn =array [1..maxn] of double;
 type tdmn=array [1..maxm+maxn] of double;
 type s100=array [1..100] of char;

 type FortranString = record
   pnt : pointer;
   len : integer;
 end;


procedure mpsinput(var filnam:FortranString; var m,n,nz,qn,qnz:integer;
  var colidx:tnz; var colnzs:tdnz; var rhs:tdm;  var lbound,ubound:tdmn;
  var colcnt,qcolcnt:tn;   var big:double; var maxm,maxn,maxnz:integer;
  var obj:tdn;     var code:integer; var buff:FortranString);
  stdcall ;  external 'mpsdll' name 'mpsinp';

procedure bpmpd(var m,n,nz,qn,qnz:integer; var acolcnt:tn;  var acolidx:tnz;
  var acolnzs:tdnz;  var qcolcnt:tn;  var qcolidx:integer;  var qcolnzs:double;
  var rhs:tdm;        var obj:tdn;  var lbound,ubound:tdmn;
  var primal,dual:tdmn; var status:tmn; var big:double; var code:integer;
  var opt:double; var usemem:integer ); stdcall ; external 'bpmpd' name 'bpmpd';

 var m,n,nz,qn,qnz,code,i,usemem:integer;
 var colidx:tnz;
 var acolcnt,qcolcnt:tn;
 var colnzs:tdnz;
 var rhs:tdm;
 var obj:tdn;
 var primal,dual:tdmn;
 var status:tmn;
 var lbound,ubound:tdmn;
 var opt,big:double;
 var filnam,buff:s100;
 var pfilnam,pbuff:FortranString;
 var ss:string;
 var maxm2,maxn2,maxnz2:integer;


procedure TForm1.Button1Click(Sender: TObject);
var xnorm:double;

begin
  pfilnam.pnt:=addr(filnam);
  pfilnam.len:=99;
  pbuff.pnt:=addr(buff);
  pbuff.len:=99;



  if OpenDialog1.Execute then begin
      for i:=1 to length(OpenDialog1.filename) do begin
        filnam[i]:=OpenDialog1.filename[i];
      end;
      for i:=length(OpenDialog1.filename)+1 to 100 do begin
        filnam[i]:=' ';
      end;
      Cursor:=crCross;
      Edit1.text:='';
      Edit2.text:='';
      Edit3.text:='';
      Edit4.text:='';
      Edit5.text:='';
      Edit6.text:='';
      Edit7.text:='Reading file';
      Edit8.text:='';
      Edit9.text:='';
      Edit10.text:='';
      Update;

      maxm2:=maxm;
      maxn2:=maxn;
      maxnz2:=maxnz;
      big    := 1.0E+30;

      mpsinput(pfilnam,m,n,nz,qn,qnz,colidx,colnzs,rhs,lbound,ubound,
        acolcnt,qcolcnt,big,maxm2,maxn2,maxnz2,obj,code,pbuff);
      Cursor:=crArrow;
      if code<0 then begin
        i:=99;
        buff[i]:=#0;
        while (i>1)and ((buff[i]=' ') or (buff[i]=#0)) do begin
          buff[i]:=#0;
          i:=i-1;
        end;
        Edit7.text:='';
        Application.MessageBox(PChar(addr(buff)),'Error in the MPS file',MB_OK);
      end else begin



        Edit1.text:=inttostr(n);
        Edit2.text:=inttostr(m);
        Edit3.text:=inttostr(nz);
        Edit8.text:=inttostr(qn);
        Edit9.text:=inttostr(qnz);
        Edit7.text:='Running Solver';
        Cursor:=crHourGlass;
        Update;

        usemem:=0;

        bpmpd(m,n,nz,qn,qnz,acolcnt,colidx,colnzs,qcolcnt,colidx[nz+1],colnzs[nz+1],
         rhs,obj,lbound,ubound,primal,dual,status,big,code,opt,usemem);

        Edit7.text:='Solver finished';
        Edit10.text:=inttostr(usemem);
        Cursor:=crArrow;
        xnorm:=0.0;
        for i:=1 to n do begin
          xnorm:=xnorm+primal[i]*primal[i];
        end;
        Edit4.text:=inttostr(code);
        str(opt,ss);
        Edit5.text:=ss;
        str(xnorm,ss);
        Edit6.text:=ss;
        Update;
      end;
  end;
end;

end.
