{

This simple application demonstrates how to set-up the input arrays for
the BPMPD dll. The program represents the convex quadratic problem described
in the bpmpdll.txt file.

}



unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit6: TEdit;
    Label6: TLabel;
    Edit7: TEdit;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
 const maxm=   40;
 const maxn=   80;
 const maxnz= 250;
 const maxqnz=125;

 type tnz  =array [1..maxnz] of integer;
 type tqnz =array [1..maxqnz] of integer;
 type tn   =array [1..maxn] of integer;
 type tmn  =array [1..maxm+maxn] of integer;
 type tdnz =array [1..maxnz] of double;
 type tdqnz=array [1..maxqnz] of double;
 type tdm  =array [1..maxm] of double;
 type tdn  =array [1..maxn] of double;
 type tdmn =array [1..maxm+maxn] of double;


procedure bpmpd(
 var m,n,nz,qn,qnz:integer;
 var acolcnt:tn;  var acolidx:tnz;  var acolnzs:tdnz;
 var qcolcnt:tn;  var qcolidx:tqnz; var qcolnzs:tdqnz;
 var rhs:tdm;     var obj:tdn;      var lbound,ubound:tdmn;
 var primal:tdmn; var dual:tdmn;    var status: tmn;
 var big:double;  var code:integer; var opt:double; var usemem:integer ); stdcall ; external 'bpmpd' name 'bpmpd';

 var m,n,nz,qn,qnz,code,i,usemem:integer;
 var acolidx:tnz;
 var qcolidx:tqnz;
 var acolcnt,qcolcnt:tn;
 var acolnzs:tdnz;
 var qcolnzs:tdqnz;
 var rhs:tdm;
 var obj:tdn;
 var lbound,ubound,primal,dual:tdmn;
 var status:tmn;
 var opt,big:double;
 var ss:string;

procedure TForm1.Button1Click(Sender: TObject);
var xnorm:double;

begin
  if {OpenDialog1.Execute}1=1 then begin
      Cursor:=crCross;
      Edit1.text:='';
      Edit2.text:='';
      Edit3.text:='';
      Edit4.text:='';
      Edit5.text:='';
      Edit6.text:='';
      Edit7.text:='Problem set-up';
      Edit9.text:='';
      Edit10.text:='';
      Update;

      big    := 1.0E+30;

      m  :=  3;
      n  :=  4;
      nz := 10;
      
      qn :=  3;
      qnz:=  4;

      obj[1]:=1; obj[2]:=  0; obj[3]:= 0; obj[4]:=0;
      rhs[1]:=0; rhs[2]:=100; rhs[3]:=10;

      ubound[1]:=20;  ubound[2]:=big; ubound[3]:=big;  ubound[4]:=big;
      ubound[5]:=big; ubound[6]:=0;   ubound[7]:=20;

      lbound[1]:=0;   lbound[2]:=0;    lbound[3]:=0;  lbound[4]:=-big;
      lbound[5]:=0;   lbound[6]:=-big; lbound[7]:=0;

      acolcnt[1]:=3; acolcnt[2]:=2; acolcnt[3]:=2; acolcnt[4]:=3;

      acolidx[1]:=1; acolidx[2]:=2; acolidx[3]:=3;
      acolidx[4]:=1; acolidx[5]:=3;
      acolidx[6]:=2; acolidx[7]:=3;
      acolidx[8]:=1; acolidx[9]:=2; acolidx[10]:=3;

      acolnzs[1]:= 1; acolnzs[2]:= 3; acolnzs[3]:= 1;
      acolnzs[4]:= 2; acolnzs[5]:= 3;
      acolnzs[6]:=-2; acolnzs[7]:= 3;
      acolnzs[8]:=-4; acolnzs[9]:=-1; acolnzs[10]:=-2;

      qcolcnt[1]:=2; qcolcnt[2]:=1; qcolcnt[3]:=0; qcolcnt[4]:=1;
      qcolidx[1]:=1; qcolidx[2]:=2; qcolidx[3]:=2; qcolidx[4]:=4;
      qcolnzs[1]:=2; qcolnzs[2]:=2; qcolnzs[3]:=4; qcolnzs[4]:=2;

      usemem :=10000;

      Edit1.text:=inttostr(n);
      Edit2.text:=inttostr(m);
      Edit3.text:=inttostr(nz);
      Edit7.text:='Running BPMPD';
      Cursor:=crHourGlass;
      Update;

      bpmpd(m,n,nz,qn,qnz,
      acolcnt,acolidx,acolnzs,
      qcolcnt,qcolidx,qcolnzs,
      rhs,obj,lbound,ubound,
      primal,dual,status,
      big,code,opt,usemem);

      Edit7.text:='BPMPD finished';
      Edit9.text:=inttostr(qn);
      Edit10.text:=inttostr(qnz);
      Cursor:=crArrow;
      xnorm:=0.0;
      for i:=1 to n do begin
        xnorm:=xnorm+primal[i]*primal[i];
      end;
      Edit4.text:=inttostr(code);
      str(opt,ss);
      Edit5.text:=ss;
      str(xnorm,ss);
      Edit6.text:=ss;
      Update;
    end;
  end;
end.
